/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package knapsack;

/**
 *
 * @author yare
 */
public class Instance {
    public Item[] items;
    public String id;
    public int capacity = 0;    // max knapsack weight (M)
    public int itemCount;       // total number of items available
    public int totalValue;      // current/total value of available items
    public int[] remValues;     // "running totals" of item values
    
    public Solution bestSolution = new Solution(this);
    public Solution[][] solMatrix;
    
    // FPTAS
    public int bits = 2;
    public int capacityShifted;
    public Item[] itemsShifted;
    
    public Instance() {
    }
    
    public void nullMatrix(){
        for (int i = 0; i < solMatrix.length; i++) {
            for (int j = 0; j < solMatrix[i].length; j++) {
                solMatrix[i][j] = null;
            }
        }
    }
    
    public void printMatrix(){
        System.out.println(">>");
        for (int i = capacity; i >= 0; i--) {
            System.out.print(i+":\t");
            for (int j = 0; j < itemCount; j++) {
                if (solMatrix[j][i] != null) {
                    System.out.print(solMatrix[j][i].value);
                }
                else System.out.print("-"); 
                
                System.out.print("\t");
            }
            System.out.println();
        }
    }

    public void initItems() {
        itemsShifted = new Item[itemCount];
        for (int i = 0; i < itemCount; i++) {
            itemsShifted[i] = items[i].clone();
        }
    }

    public Item[] cloneItems() {
        Item[] itemsClone = new Item[itemCount];
        for (int i = 0; i < itemCount; i++) {
            itemsClone[i] = items[i].clone();
        }
        return itemsClone;
    }
    
}
