/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package knapsack;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

/**
 *
 * @author yare
 */
public class Population {

//    public Solution[] genoms;
    public List<Solution> genoms;
    public Instance instance;

    public Population(Instance instance) {
//        this.genoms = new Solution[size];
        this.genoms = new ArrayList<Solution>();
        this.instance = instance;
    }

    public static Population generate(Instance instance, int size) {
        Population pop = new Population(instance);
        for (int i = 0; i < size; i++) {
            pop.genoms.add(Solution.generate(instance));
        }
        return pop;
    }

    /*
     * returns best genom from the Population
     */
    public Solution getBest() {
        Solution best = null;
        if (genoms.size() > 0) {
            best = genoms.get(0);
        }
        for (int i = 0; i < genoms.size(); i++) {
            if (genoms.get(i).getFitness() > best.getFitness()) {
                best = genoms.get(i);
            }
        }
        return best;
    }

    public Population selectFrom(Population pop, double selectionPressure) {

//        int remove = (int) Math.round((1 - selectionPressure) * pop.genoms.length);

        return pop;
    }

    public Population select(double selectionPressure) {

        Population newPop = new Population(instance);

        int remove = (int) Math.round((1 - selectionPressure) * this.genoms.size());
        Random random = new Random();

        // N-times:
        for (int i = 0; i < this.genoms.size(); i++) {

            // this.genoms choose randomly (K-remove) items
            Population p = new Population(instance);
            p.genoms.addAll(this.genoms);
            for (int j = 0; j < remove; j++) {
                int index = random.nextInt(p.genoms.size());
                p.genoms.remove(index);
            }

            // best of tournament to the new population
            newPop.genoms.add(p.getBest().clone());
        }
        return newPop;
    }

    public void crossover(double pCrossover) {

        Random random = new Random();
        for (int i = 0; i < this.genoms.size(); i += 2) {

            if (i == (this.genoms.size() - 1)) {
                continue;
            }

            if (Math.random() < pCrossover) {

                Solution s1 = this.genoms.get(i);
                Solution s2 = this.genoms.get(i + 1);


                // crossover bits behind some level
                int threshold = random.nextInt(s1.taken.length - 1);
                int[] tmp = new int[s1.taken.length];
                System.arraycopy(s1.taken, 0, tmp, 0, threshold);
                System.arraycopy(s2.taken, 0, s1.taken, 0, threshold);
                System.arraycopy(tmp, 0, s2.taken, 0, threshold);
            }
        }
    }

    public void mutate(double pMutation) {
        for (int i = 0; i < this.genoms.size(); i++) {
            for (int j = 0; j < instance.itemCount; j++) {
                if (Math.random() < pMutation) {
                    if (this.genoms.get(i).taken[j] == 0) {
                        this.genoms.get(i).taken[j] = 1;
                    } else {
                        this.genoms.get(i).taken[j] = 0;
                    }
                }
            }

        }
    }
}
