package knapsack;

import java.util.Arrays;
import java.util.Random;

/**
 *
 * @author Jaroslav Fibichr
 */
public class Solution {

    static Solution generate(Instance instance) {
        Solution s = new Solution(instance);
        Random r = new Random();
        for (int i = 0; i < instance.itemCount; i++) {
            s.taken[i] = r.nextInt(2);
        }
        return s;
    }
    public int capacity;
    public int remCapacity;
    public int value;
    public int itemsCount;
    public int[] taken;
    public int remValue;
    public Instance instance;

    public Solution(int capacity, int remCapacity, int value, int itemsCount) {
        this.capacity = capacity;
        this.remCapacity = remCapacity;
        this.value = value;
        this.itemsCount = itemsCount;

        this.taken = new int[itemsCount];
    }

    public Solution(Instance instance) {
        this.capacity = instance.capacity;
        this.remCapacity = instance.capacity;
        this.value = 0;
        this.remValue = instance.totalValue;
        this.itemsCount = instance.itemCount;
        this.taken = new int[itemsCount];
        Arrays.fill(taken, 0);
        this.instance = instance;
    }

    public Solution(int capacity, int itemsCount) {
        this.capacity = capacity;
        this.remCapacity = capacity;
        this.value = 0;
        this.itemsCount = itemsCount;

        this.taken = new int[itemsCount];
        Arrays.fill(this.taken, 0);

    }

    private Solution() {
    }

    @Override
    public Solution clone() {
        Solution sol = new Solution();
        sol.capacity = this.capacity;
        sol.remCapacity = this.remCapacity;
        sol.value = this.value;
        sol.itemsCount = this.itemsCount;

        sol.taken = new int[this.itemsCount];
        for (int i = 0; i < this.taken.length; ++i) {
            sol.taken[i] = this.taken[i];
        }
        sol.instance = this.instance;
        return sol;
    }

    public void print() {
        System.out.print(">> solution: " + value);

        for (int i = 0; i < this.taken.length; ++i) {
            System.out.print(" " + this.taken[i]);
        }
        System.out.println();
    }

    public int compare(Solution sol) {
        int from = this.getFitness();
        int to =  sol.getFitness();
        
        if (from < to) {
            return -1;
        } else if (from > to) {
            return 1;
        }
        return 0;
    }

    public int getFitness() {
        int result = 0;
        int sumV = 0;
        int sumW = 0;
        for (int i = 0; i < taken.length; i++) {
            if (taken[i] == 1) {
                sumW += instance.items[i].weight;
                sumV += instance.items[i].value;
            }
        }
        if (capacity < sumW) { // pokud překročí váhu -> fitness 0
            return 0;
        }
        return sumV;
    }
    
    
}
