/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package knapsack.algorithms;

import knapsack.Instance;
import knapsack.Solution;

/**
 *
 * @author yare
 */
public class BranchAndBound implements Algorithm {
    
    private static final String NAME = "Branch&Bound";
    
    public String getName(){
        return NAME;
    }
    
    private Solution solveBaB(Instance instance, Solution solution, int index) {
                
        if (index < 0) {
            return solution;
        }

        // BaB
        if (instance.items[index].weight > solution.remCapacity) {
            return solveBaB(instance, solution, index - 1);
        }
        if (instance.remValues[index] + solution.value < instance.bestSolution.value) {
            return solution;
        }
        
        Solution s1 = solution;
        Solution s2 = solution.clone();
        
        s2.value += instance.items[index].value;
        s2.remCapacity -= instance.items[index].weight;
        s2.taken[index] = 1;
        
        s1.remValue -= instance.items[index].value;  // BaB
        s2.remValue -= instance.items[index].value;  // BaB

        s1 = solveBaB(instance, s1, index - 1);
        s2 = solveBaB(instance, s2, index - 1);
        
        solution = s1.value < s2.value ? s2 : s1;
        instance.bestSolution = solution;           // BaB
        return solution;
    }
    
    @Override
    public Solution run(Instance instance, Solution solution) {
        return solveBaB(instance, solution, instance.itemCount - 1);
    }
}
