/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package knapsack.algorithms;

import knapsack.Instance;
import knapsack.Solution;

/**
 *
 * @author yare
 */
public class Dynamic implements Algorithm {
    
    private static final String NAME = "Dynamic";
    
    public String getName(){
        return NAME;
    }
    
    private Solution solveDynamic(Instance instance, Solution solution, int index, int weight) {
                
        if (weight < 0) {
            Solution s = new Solution(instance);
            s.value = Integer.MIN_VALUE;
            return s;
        }
        if (index < 0) {
            return new Solution(instance);
        }

        // return already known
        if (instance.solMatrix[index][weight] != null){
            return instance.solMatrix[index][weight].clone();
        }
        
        Solution s1 = solution;
        Solution s2 = solution.clone();
        
        s1 = solveDynamic(instance, s1, index - 1, weight );
        s2 = solveDynamic(instance, s2, index - 1, weight - instance.items[index].weight);
        
        s2.value += instance.items[index].value;
        s2.remCapacity -= instance.items[index].weight;
        s2.taken[index] = 1;
        
        Solution result  = s1.value < s2.value ? s2 : s1;
        instance.solMatrix[index][weight] = result.clone();
        
//        instance.printMatrix();
        return result;
    }
    
    @Override
    public Solution run(Instance instance, Solution solution) {
        instance.nullMatrix();
        return solveDynamic(instance, solution, instance.itemCount - 1, instance.capacity);
    }
}
