/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package knapsack.algorithms;

import knapsack.Instance;
import knapsack.Item;
import knapsack.Solution;

/**
 *
 * @author yare
 */
public class FPTAS implements Algorithm {
    
    private static final String NAME = "FPTAS";
    private int bits = 2;
    
    public FPTAS(int bits) {
        this.bits = bits;
    }
    
    public String getName(){
        return NAME;
    }
    
    @Override
    public Solution run(Instance instance, Solution solution) {
        
        // init
        instance.nullMatrix();
        
        if (bits < 0 || bits > Integer.SIZE) {
            System.out.println("Bad idea.");
            return null;
        }
        
        // save original capacity & items
        int capacityTmp = instance.capacity;
        Item[] itemsTmp = instance.cloneItems();
        
        instance.capacity = instance.capacity >> bits;
        for (int i = 0; i < instance.itemCount; i++) {
            instance.items[i].weight = instance.items[i].weight >> bits;
        }
        instance.solMatrix = new Solution[instance.itemCount][instance.capacity+1];
        
        Algorithm algorithm = new Dynamic();
        Solution result = algorithm.run(instance, solution);
        
        // swap back capacity & items 
        instance.items = itemsTmp;
        instance.capacity = capacityTmp;
        return result;
    }
}
