package knapsack.algorithms;

import knapsack.Instance;
import knapsack.Population;
import knapsack.Solution;

/**
 *
 * @author Jaroslav Fibichr
 */
public class Genetic implements Algorithm {
    
    private static final String NAME = "Genetic";
    
    public static int POPULATION_SIZE = 100;     // 50
    public static double SELECTION_PRESSURE = 0.3;     // 0.3
    public static int GENERATION_COUNT = 10;      // 1000 
    public static double P_CROSSOVER = 0.7;         // 0.7  
    public static double P_MUTATION = 0.05;         // 0.05
    
    public String getName(){
        return NAME;
    }
    
    private Solution solveGenetic(Instance instance) {
        
        Population pop = Population.generate(instance, POPULATION_SIZE);
        
        for (int i = 0; i < GENERATION_COUNT; i++) {
           Population newPop = pop.select(SELECTION_PRESSURE);
           newPop.crossover(P_CROSSOVER);
           newPop.mutate(P_MUTATION);
           pop = newPop;
        }
        Solution solution = pop.getBest();
        solution.value = solution.getFitness();
        return solution;
    }
    
    @Override
    public Solution run(Instance instance, Solution solution) {
        return solveGenetic(instance);
    }
}
